function appItemPositionChanged(mouseArea, pageChangeTimer, toDesktopTimer, appIconItem, appIconItemRoot) {
    if (mouseArea.Drag.active && !mouseArea.groupHeightChanged &&
            (appIconItemRoot.x - mouseArea.startDragPoint.x > 0
             || appIconItemRoot.y - mouseArea.startDragPoint.y > 0)) {
        changeGroupHeight()
        mouseArea.groupHeightChanged = true
    }

    if (allowGroupItemToTaskbar) {
        appIconItem.iconWidth = 64 * Style.tabletScaleFactor
    }

    if (!allowGroupItemToTaskbar && itemRoot.Drag.active) {
        appIconItem.iconWidth = 96 * Style.tabletScaleFactor * 1.1
    }

    if (appIconContainer.containerState === LauncherItem.Editable) {
        return
    }

    var itemPos = appIconItem.mapToItem(listView, 0, 0)
    if (itemPos.x % listView.width < -appIconItem.width ||
                itemPos.x > listView.width ||
                itemPos.y % listView.height < -appIconItem.height ||
                itemPos.y > listView.height) {
        pageChangeTimer.stop()
        mouseArea.isChangeListviewPage = false
        if (GroupController.groupPopuped) {
            toDesktopTimer.start()
        }
    } else if ((itemPos.x % listView.width) >= (listView.width - appIconItem.width + 32 * Style.tabletScaleFactor) &&
            mouseArea.Drag.active) {
        pageChangeTimer.start()
        toDesktopTimer.stop()
        if (mouseArea.isChangeListviewPage) {
            if (listView.currentIndex < listView.count - 1) {
                listView.currentIndex ++
                modelManager.removePlaceholderItem()
                // 拖动至不同页时才添加 placeholder item
                if (mouseArea.drag.target.pageIndex !== listView.currentIndex) {
                    var groupCurItemCount = modelManager.groupPageItemCount(groupId, listView.currentIndex)
                    var index = groupCurItemCount > 0 ? groupCurItemCount : 0
                    modelManager.addPlaceholderItem(index, listView.currentIndex, mouseArea.drag.target.rowSpan,
                                mouseArea.drag.target.columnSpan, groupId)
                }
                mouseArea.isChangeListviewPage = false
                pageChangeTimer.restart()
            } else {
                appIconItem.x = 0
            }
        }
    } else if ((itemPos.x % listView.width < -32 * Style.tabletScaleFactor) &&
               mouseArea.Drag.active) {
        pageChangeTimer.start()
        toDesktopTimer.stop()
        if (mouseArea.isChangeListviewPage && listView.currentIndex > 0) {
            listView.currentIndex --
            modelManager.removePlaceholderItem()
            if (mouseArea.drag.target.pageIndex !== listView.currentIndex) {
                groupCurItemCount = modelManager.groupPageItemCount(groupId, listView.currentIndex)
                index = groupCurItemCount > 0 ? groupCurItemCount : 0
                modelManager.addPlaceholderItem(index, listView.currentIndex, mouseArea.drag.target.rowSpan,
                            mouseArea.drag.target.columnSpan, groupId)
            }

            mouseArea.isChangeListviewPage = false
            pageChangeTimer.restart()
        }
    } else {
        pageChangeTimer.stop()
        toDesktopTimer.stop()
        mouseArea.isChangeListviewPage = false
    }
}
